###################################################
### chunk number 1: loadPackage
###################################################
#line 70 "d:/Rcompile/CRANpkg/local/2.12/pathClass/inst/doc/pathClass.rnw"
library(pathClass)


###################################################
### chunk number 2: loadALLpackage
###################################################
#line 87 "d:/Rcompile/CRANpkg/local/2.12/pathClass/inst/doc/pathClass.rnw"
library(golubEsets)
data(Golub_Merge)


###################################################
### chunk number 3: classLabels
###################################################
#line 94 "d:/Rcompile/CRANpkg/local/2.12/pathClass/inst/doc/pathClass.rnw"
y <- pData(Golub_Merge)$ALL


###################################################
### chunk number 4: loadDataMatrix
###################################################
#line 105 "d:/Rcompile/CRANpkg/local/2.12/pathClass/inst/doc/pathClass.rnw"
x <- exprs(Golub_Merge)


###################################################
### chunk number 5: dataMatrix
###################################################
#line 112 "d:/Rcompile/CRANpkg/local/2.12/pathClass/inst/doc/pathClass.rnw"
x <- t(x)
dim(x)


###################################################
### chunk number 6: hprd eval=FALSE
###################################################
## #line 125 "d:/Rcompile/CRANpkg/local/2.12/pathClass/inst/doc/pathClass.rnw"
## hprd <- read.hprd('BINARY_PROTEIN_PROTEIN_INTERACTIONS.txt')


###################################################
### chunk number 7: hprd2 eval=FALSE
###################################################
## #line 137 "d:/Rcompile/CRANpkg/local/2.12/pathClass/inst/doc/pathClass.rnw"
## data(adjacency.matrix)
## hprd <- adjacency.matrix


###################################################
### chunk number 8: mapping
###################################################
#line 148 "d:/Rcompile/CRANpkg/local/2.12/pathClass/inst/doc/pathClass.rnw"
ann <- annotation(Golub_Merge)
library(paste(ann,'db',sep='.'), character.only=TRUE)

graphIDs <- "REFSEQ"
rs <- get(paste(ann, graphIDs, sep=''))
refseq <- mget(featureNames(Golub_Merge), rs)
times <- sapply(refseq, length)
mapping <- data.frame(probesetID=rep(names(refseq), times=times),
                      graphID=unlist(refseq),
                      row.names=NULL,
                      stringsAsFactors=FALSE)
nas <- which(is.na(mapping[,'graphID']))
mapping <- mapping[-nas,]
mapping <- unique(mapping)
head(mapping)


###################################################
### chunk number 9: matchMatrices eval=FALSE
###################################################
## #line 182 "d:/Rcompile/CRANpkg/local/2.12/pathClass/inst/doc/pathClass.rnw"
## matched <- matchMatrices(x=x, adjacency=hprd, mapping=mapping)


###################################################
### chunk number 10: RRFE eval=FALSE
###################################################
## #line 234 "d:/Rcompile/CRANpkg/local/2.12/pathClass/inst/doc/pathClass.rnw"
## set.seed(12345)
## res.rrfe <- crossval(x,
##                      y,
##                      DEBUG=TRUE,
##                      theta.fit=fit.rrfe,
##                      folds=10,
##                      repeats=5,
##                      parallel=TRUE,
##                      Cs=10^(-3:3),
##                      mapping=mapping,
##                      Gsub=hprd,
##                      d=1/2)


###################################################
### chunk number 11: RRFEallFeatures eval=FALSE
###################################################
## #line 249 "d:/Rcompile/CRANpkg/local/2.12/pathClass/inst/doc/pathClass.rnw"
## res.rrfe <- crossval(x,
##                      y,
##                      DEBUG=TRUE,
##                      theta.fit=fit.rrfe,
##                      folds=10,
##                      repeats=5,
##                      parallel=TRUE,
##                      Cs=10^(-3:3),
##                      useAllFeatures=TRUE,
##                      mapping=mapping,
##                      Gsub=hprd,
##                      d=1/2)


###################################################
### chunk number 12: networkBasedSVM eval=FALSE
###################################################
## #line 273 "d:/Rcompile/CRANpkg/local/2.12/pathClass/inst/doc/pathClass.rnw"
## ad.list <- as.adjacencyList(matched$adjacency)
## 
## set.seed(12345)
## res.nBSVM <- crossval(matched$x,
##                       y,
##                       theta.fit=fit.networkBasedSVM,
##                       folds=10,
##                       repeats=5,
##                       DEBUG=TRUE,
##                       parallel=FALSE,
##                       adjacencyList=ad.list,
##                       lambdas=10^(-1:2),
##                       sd.cutoff=150)


###################################################
### chunk number 13: graphSVM eval=FALSE
###################################################
## #line 302 "d:/Rcompile/CRANpkg/local/2.12/pathClass/inst/doc/pathClass.rnw"
## dk <- calc.diffusionKernel(L=matched$adjacency,
##                            is.adjacency=TRUE,
##                            beta=0)
## 
## set.seed(12345)
## res.gSVM <- crossval(matched$x,
##                      y,
##                      theta.fit=fit.graph.svm,
##                      folds=10,
##                      repeats=5,
##                      DEBUG=TRUE,
##                      parallel=FALSE,
##                      Cs=10^(-3:3),
##                      mapping=matched$mapping,
##                      diffusionKernel=dk)


###################################################
### chunk number 14: plotting eval=FALSE
###################################################
## #line 325 "d:/Rcompile/CRANpkg/local/2.12/pathClass/inst/doc/pathClass.rnw"
## plot(res.rrfe, toFile=F)


###################################################
### chunk number 15: benchmark eval=FALSE
###################################################
## #line 337 "d:/Rcompile/CRANpkg/local/2.12/pathClass/inst/doc/pathClass.rnw"
## cv.labels <- matrix(rep(y,5), ncol=5)
## pred.rrfe <- prediction(res.rrfe$cv, labels=cv.labels)
## auc.rrfe  <- round(mean(unlist(performance(pred.rrfe, 'auc')@y.values)),3)
## plot(performance(pred.rrfe, measure = "tpr", x.measure = "fpr"),
##      col='red',
##      main='Benchmark of the algorithms',
##      avg = "threshold")
## 
## pred.nBSVM <- prediction(res.nBSVM$cv, labels=cv.labels)
## auc.nBSVM  <- round(mean(unlist(performance(pred.nBSVM, 'auc')@y.values)),3)
## plot(performance(pred.nBSVM, measure = "tpr", x.measure = "fpr"),
##      add=TRUE,
##      col='blue',
##      avg = "threshold")
## 
## pred.gSVM <- prediction(res.gSVM$cv, labels=cv.labels)
## auc.gSVM  <- round(mean(unlist(performance(pred.gSVM, 'auc')@y.values)),3)
## plot(performance(pred.gSVM, measure = "tpr", x.measure = "fpr"),
##      add=TRUE,
##      col='green',
##      avg = "threshold")
## 
## legend('bottomright',
##        c(paste('RRFE (AUC=',auc.rrfe,')',sep=''),
##          paste('network based SVM (AUC=',auc.nBSVM,')',sep=''),
##          paste('graph SVM (AUC=',auc.gSVM,')',sep='')),
##        text.col=c('red','blue','green'),
##        col=c('red','blue','green'),
##        lty=1,
##        bty='n',
##        cex=1.3)
## 
## abline(b=1,a=0,col='gray')


###################################################
### chunk number 16: extrFeatures eval=FALSE
###################################################
## #line 390 "d:/Rcompile/CRANpkg/local/2.12/pathClass/inst/doc/pathClass.rnw"
## extractFeatures(res.rrfe, toFile=T, fName='OurFeatures.csv')


